=== ajantv2/CMakeLists.txt ===
project(ajantv2)

include(CMakePackageConfigHelpers)
include(ExternalProject)

if (CMAKE_CXX_STANDARD EQUAL 98)
    message(STATUS "ajantv2 building for C++98")
    remove_definitions(
        -DAJA_USE_CPLUSPLUS11
        -DNTV2_USE_CPLUSPLUS11)

    set(_ajabase_types_path "../ajabase/common/types.h")
    file(READ ${_ajabase_types_path} _ajabase_types_file)
    STRING(REPLACE "#define AJA_USE_CPLUSPLUS11" "//#define AJA_USE_CPLUSPLUS11 " _ajabase_types_file "${_ajabase_types_file}")
    file(WRITE ${_ajabase_types_path} "${_ajabase_types_file}")
    message(STATUS "Overwrote ${_ajabase_types_path} to remove AJA_USE_CPLUSPLUS11 define!")

    set(_ajantv2_ajatypes_path "includes/ajatypes.h")
    file(READ ${_ajantv2_ajatypes_path} _ajatypes_file)
    STRING(REPLACE "#define NTV2_USE_CPLUSPLUS11" "//#define NTV2_USE_CPLUSPLUS11 " _ajatypes_file "${_ajatypes_file}")
    file(WRITE ${_ajantv2_ajatypes_path} "${_ajatypes_file}")
    message(STATUS "Overwrote ${_ajantv2_ajatypes_path} to remove NTV2_USE_CPLUSPLUS11 define!")
elseif(CMAKE_CXX_STANDARD GREATER_EQUAL 11)
    message(STATUS "ajantv2 building for C++11")
    list(APPEND TARGET_COMPILE_DEFS
        -DAJA_USE_CPLUSPLUS11
        -DNTV2_USE_CPLUSPLUS11)
else()
    message(FATAL_ERROR "Unsupported C++ standard! NTV2 requires C++98 or higher. CMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}")
endif()

remove_definitions(
    -DQT_LARGEFILE_SUPPORT)

set(TARGET_INCLUDE_DIRS
    ${LIBAJANTV2_DIR}
    ${LIBAJANTV2_DIR}/ajaanc/includes
    ${LIBAJANTV2_DIR}/ajabase
    ${LIBAJANTV2_DIR}/ajantv2/includes
    ${CMAKE_CURRENT_BINARY_DIR}
)

set(INSTALL_INCLUDE_DIRS
    ${CMAKE_INSTALL_INCLUDEDIR}/libajantv2
    ${CMAKE_INSTALL_INCLUDEDIR}/libajantv2/ajantv2/includes
)

if (AJANTV2_DISABLE_PLUGIN_LOAD)
    message(STATUS "NTV2 SDK will NOT load 3rd-party plugins")
    list(APPEND TARGET_COMPILE_DEFS
        -DNTV2_PREVENT_PLUGIN_LOAD)
else()
    if(NOT DEFINED AJANTV2_MBEDTLS_URL)
        set(AJANTV2_MBEDTLS_URL https://github.com/aja-video/mbedtls.git)
    endif()
    message(STATUS "NTV2 SDK will load signed 3rd-party plugins")

    set(MBEDTLS_INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/mbedtls-install)
    set(MBEDTLS_INCLUDE_DIR ${MBEDTLS_INSTALL_DIR}/include)
    set(MBEDTLS_LIBRARY_DIR ${MBEDTLS_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR})

    if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
        set(MBEDTLS_LIBRARY ${MBEDTLS_LIBRARY_DIR}/mbedtls.lib)
        set(MBEDX509_LIBRARY ${MBEDTLS_LIBRARY_DIR}/mbedx509.lib)
        set(MBEDCRYPTO_LIBRARY ${MBEDTLS_LIBRARY_DIR}/mbedcrypto.lib)
        set(MBEDTLS_EXTRA_CONFIG_FLAGS
                "-DCMAKE_WINDOWS_EXPORT_ALL_SYMBOLS=ON"
                "-DCMAKE_MSVC_RUNTIME_LIBRARY=${CMAKE_MSVC_RUNTIME_LIBRARY}")
    elseif (CMAKE_SYSTEM_NAME MATCHES "^(Linux|Darwin)$")
        set(MBEDTLS_LIBRARY ${MBEDTLS_LIBRARY_DIR}/libmbedtls.a)
        set(MBEDX509_LIBRARY ${MBEDTLS_LIBRARY_DIR}/libmbedx509.a)
        set(MBEDCRYPTO_LIBRARY ${MBEDTLS_LIBRARY_DIR}/libmbedcrypto.a)
        set(MBEDTLS_C_FLAGS -fPIC)
    endif()

    # BUILD_BYPRODUCTS informing CMake where the .a files are located is required to make Ninja build work
    ExternalProject_Add(
        mbedtls
        GIT_REPOSITORY ${AJANTV2_MBEDTLS_URL}
        GIT_TAG fix-win-dll-cmake
        CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${MBEDTLS_INSTALL_DIR}
                    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
                    -DENABLE_TESTING=OFF 
                    -DENABLE_PROGRAMS=OFF
                    -DCMAKE_C_FLAGS=${MBEDTLS_C_FLAGS}
                    -DCMAKE_OSX_DEPLOYMENT_TARGET=${CMAKE_OSX_DEPLOYMENT_TARGET}
                    -DUSE_STATIC_MBEDTLS_LIBRARY=ON
                    -DUSE_SHARED_MBEDTLS_LIBRARY=OFF
                    ${MBEDTLS_EXTRA_CONFIG_FLAGS}
		CMAKE_CACHE_ARGS "-DCMAKE_OSX_ARCHITECTURES:STRING=${CMAKE_OSX_ARCHITECTURES}"
        BUILD_ALWAYS TRUE
        BUILD_BYPRODUCTS ${MBEDTLS_LIBRARY} ${MBEDX509_LIBRARY} ${MBEDCRYPTO_LIBRARY}
    )

    list(APPEND TARGET_INCLUDE_DIRS
            ${MBEDTLS_INCLUDE_DIR})
    list(APPEND MBEDTLS_LINK_LIBS
            ${MBEDTLS_LIBRARY}
            ${MBEDCRYPTO_LIBRARY}
            ${MBEDX509_LIBRARY})
endif()


# ajantv2
set(AJANTV2_HEADERS
    includes/ajaexport.h
    includes/ajatypes.h
    includes/basemachinecontrol.h
    includes/ntv2audiodefines.h
    includes/ntv2bft.h
    includes/ntv2bitfile.h
    includes/ntv2bitfilemanager.h
#   includes/ntv2boardfeatures.h	# removed in SDK 17.0
#   includes/ntv2boardscan.h		# removed in SDK 17.0
    includes/ntv2card.h
    includes/ntv2choosableboard.h
    includes/ntv2config2022.h
    includes/ntv2config2110.h
    includes/ntv2configts2022.h
    includes/ntv2cscmatrix.h
    includes/ntv2debug.h
    includes/ntv2debugmacros.h
    includes/ntv2devicecapabilities.h
    includes/ntv2devicefeatures.h
    includes/ntv2devicefeatures.hh # generated by sdkgen
    includes/ntv2devicescanner.h
#   includes/ntv2discover.h	# removed in SDK 17.0
    includes/ntv2driverinterface.h
    includes/ntv2endian.h
    includes/ntv2enhancedcsc.h
    includes/ntv2enums.h
    includes/ntv2fixed.h
    includes/ntv2formatdescriptor.h
    includes/ntv2konaflashprogram.h
    includes/ntv2m31enums.h
    includes/ntv2m31publicinterface.h
    includes/ntv2mailbox.h
    includes/ntv2mbcontroller.h
    includes/ntv2mcsfile.h
    includes/ntv2nubaccess.h
    includes/ntv2nubtypes.h
#   includes/ntv2nubpktcom.h	# removed in SDK 17.0
    includes/ntv2publicinterface.h
    includes/ntv2registerexpert.h
    includes/ntv2registers2022.h
    includes/ntv2registers2110.h
    includes/ntv2registersmb.h
    includes/ntv2resample.h
    includes/ntv2routingexpert.h
    includes/ntv2rp188.h
#   includes/ntv2rp215.h	# removed in SDK 17.0
    includes/ntv2serialcontrol.h
    includes/ntv2signalrouter.h
    includes/ntv2spiinterface.h
    includes/ntv2supportlogger.h
    includes/ntv2task.h
    includes/ntv2testpatterngen.h
    includes/ntv2transcode.h
    includes/ntv2tshelper.h
#   includes/ntv2utf8.h	# removed in SDK 17.1
    includes/ntv2utils.h
    includes/ntv2verticalfilter.h
    includes/ntv2videodefines.h
    includes/ntv2virtualregisters.h
    includes/ntv2vpid.h
    includes/ntv2vpidfromspec.h)
set(AJANTV2_SOURCES
    src/ntv2anc.cpp
    src/ntv2aux.cpp
    src/ntv2audio.cpp
    src/ntv2autocirculate.cpp
    src/ntv2bitfile.cpp
    src/ntv2bitfilemanager.cpp
    src/ntv2card.cpp
    src/ntv2config2022.cpp
    src/ntv2config2110.cpp
    src/ntv2configts2022.cpp
    src/ntv2csclut.cpp
    src/ntv2cscmatrix.cpp
    src/ntv2debug.cpp
    src/ntv2devicefeatures.cpp
    src/ntv2devicefeatures.hpp	# generated by sdkgen
    src/ntv2devicescanner.cpp
#   src/ntv2discover.cpp		# removed in SDK 17.0
    src/ntv2dma.cpp
    src/ntv2driverinterface.cpp
    src/ntv2dynamicdevice.cpp
    src/ntv2enhancedcsc.cpp
    src/ntv2formatdescriptor.cpp
    src/ntv2hdmi.cpp
    src/ntv2hevc.cpp
    src/ntv2interrupts.cpp
    src/ntv2konaflashprogram.cpp
    src/ntv2mailbox.cpp
    src/ntv2mbcontroller.cpp
    src/ntv2mcsfile.cpp
    src/ntv2nubaccess.cpp
#   src/ntv2nubpktcom.cpp		# removed in SDK 17.0
    src/ntv2publicinterface.cpp
    src/ntv2regconv.cpp			# added in SDK 17.0
    src/ntv2register.cpp
    src/ntv2registerexpert.cpp
    src/ntv2regroute.cpp		# added in SDK 17.0
    src/ntv2regvpid.cpp			# added in SDK 17.0
    src/ntv2resample.cpp
    src/ntv2routingexpert.cpp
    src/ntv2rp188.cpp
#   src/ntv2rp215.cpp			# removed in SDK 17.0
    src/ntv2serialcontrol.cpp
    src/ntv2signalrouter.cpp
    src/ntv2spiinterface.cpp
    src/ntv2stream.cpp
    src/ntv2subscriptions.cpp
    src/ntv2supportlogger.cpp
    src/ntv2task.cpp
    src/ntv2testpatterngen.cpp
    src/ntv2transcode.cpp
#   src/ntv2utf8.cpp			# removed in SDK 17.1
    src/ntv2utils.cpp
    src/ntv2version.cpp
    src/ntv2verticalfilter.cpp
    src/ntv2vpid.cpp
    src/ntv2vpidfromspec.cpp)
# ntv2driverinterface/publicinterface
set(AJANTV2_WIN_HEADERS
    src/win/ntv2windriverinterface.h
    src/win/ntv2winpublicinterface.h)
set(AJANTV2_WIN_SOURCES
    # src/win/dllmain.cpp
    src/win/ntv2windriverinterface.cpp)
set(AJANTV2_MAC_HEADERS
    src/mac/ntv2macdriverinterface.h
    src/mac/ntv2macpublicinterface.h)
set(AJANTV2_MAC_SOURCES
    src/mac/ntv2macdriverinterface.cpp)
set(AJANTV2_LIN_HEADERS
    src/lin/ntv2linuxdriverinterface.h
    src/lin/ntv2linuxpublicinterface.h)
set(AJANTV2_LIN_SOURCES
    src/lin/ntv2linuxdriverinterface.cpp)
set(AJANTV2_BM_HEADERS
    src/bm/ntv2baremetaldriverinterface.h
    src/bm/ntv2baremetalpublicinterface.h)
set(AJANTV2_BM_SOURCES
    src/bm/ntv2baremetaldriverinterface.cpp)
# ajantv2 utilityfiles
set(AJANTV2_UTILITY_PUBLIC_HEADERS
    utilityfiles/public/ntv2firmwareinstallerthread.h
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.h)
set(AJANTV2_UTILITY_PUBLIC_SOURCES
    utilityfiles/public/ntv2firmwareinstallerthread.cpp
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.cpp)

if (NOT AJANTV2_BUILD_OPENSOURCE)
    # ajantv2 hevc codec sources
    if (EXISTS ${LIBAJANTV2_PRIVATE_DIR})
        set(AJANTV2_HEVC_HEADERS
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31cparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31ehparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vaparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vinparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31viparam.h)
        set(AJANTV2_HEVC_SOURCES
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31cparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31ehparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vaparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vinparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31viparam.cpp)
        # `cmake --install` deployments
        if (AJA_INSTALL_HEADERS)
            install(FILES ${AJANTV2_HEVC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libajantv2/ajantv2/codecs/hevc/m31)
        endif()
        if (AJA_INSTALL_SOURCES)
            install(FILES ${AJANTV2_HEVC_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/ajantv2/codecs/hevc/m31)
        endif()
        message(STATUS "added ajantv2 HEVC/M31 codec sources from ${LIBAJANTV2_PRIVATE_DIR}")
    else()
        message(STATUS "ajantv2 private repo sources not found: ${LIBAJANTV2_PRIVATE_DIR}")
    endif()
endif()

configure_file(includes/ntv2version.h.in includes/ntv2version.h @ONLY)
configure_file(includes/ntv2version.h.in ${CMAKE_CURRENT_SOURCE_DIR}/includes/ntv2version.h @ONLY)

# ajaanc
set(AJAANC_HEADERS
    ../ajaanc/includes/ancillarydata.h
    ../ajaanc/includes/ancillarydatafactory.h
    ../ajaanc/includes/ancillarydata_cea608.h
    ../ajaanc/includes/ancillarydata_cea608_line21.h
    ../ajaanc/includes/ancillarydata_cea608_vanc.h
    ../ajaanc/includes/ancillarydata_cea708.h
    ../ajaanc/includes/ancillarydata_framestatusinfo524D.h
    ../ajaanc/includes/ancillarydata_framestatusinfo5251.h
    ../ajaanc/includes/ancillarydata_hdr_hdr10.h
    ../ajaanc/includes/ancillarydata_hdr_hlg.h
    ../ajaanc/includes/ancillarydata_hdr_sdr.h
    ../ajaanc/includes/ancillarydata_timecode.h
    ../ajaanc/includes/ancillarydata_timecode_atc.h
    ../ajaanc/includes/ancillarydata_timecode_vitc.h
    ../ajaanc/includes/ancillarydata_hdmi_aux.h
    ../ajaanc/includes/ancillarylist.h)
set(AJAANC_SOURCES
    ../ajaanc/src/ancillarydata.cpp
    ../ajaanc/src/ancillarydatafactory.cpp
    ../ajaanc/src/ancillarydata_cea608.cpp
    ../ajaanc/src/ancillarydata_cea608_line21.cpp
    ../ajaanc/src/ancillarydata_cea608_vanc.cpp
    ../ajaanc/src/ancillarydata_cea708.cpp
    ../ajaanc/src/ancillarydata_framestatusinfo524D.cpp
    ../ajaanc/src/ancillarydata_framestatusinfo5251.cpp
    ../ajaanc/src/ancillarydata_hdr_hdr10.cpp
