=== demos/AMD/CMakeLists.txt ===
message(STATUS "AMD demos not yet implemented")
return()
