=== debian/changelog ===
libajantv2-dmo (17.5.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 08 Apr 2025 08:50:56 +0200

libajantv2-dmo (17.1.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 17 Dec 2024 01:43:10 +0100

libajantv2-dmo (17.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 25 Jul 2024 01:18:03 +0200

libajantv2-dmo (17.0.1-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 14 Jun 2024 15:19:33 +0200
