=== debian/control ===
Source: libajantv2-dmo
Section: libdevel
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/aja-video/libajantv2
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, libudev-dev,

Package: libajantv2-dev
Architecture: any
Multi-Arch: same
#Depends: libajantv2-17 (= ${binary:Version}), ${misc:Depends},
Depends: ${misc:Depends},
Description: Open-source library for AJA Video Systems desktop IO cards.
 This is the open-source SDK for discovering, interrogating and controlling
 NTV2 professional video I/O devices from AJA Video Systems, Inc. All code
 herein is licensed under the MIT license.

#Package: libajantv2-17
#Architecture: any
#Multi-Arch: same
#Depends: ${shlibs:Depends}, ${misc:Depends},
#Description: Open-source library for AJA Video Systems desktop IO cards.
# This is the open-source SDK for discovering, interrogating and controlling
# NTV2 professional video I/O devices from AJA Video Systems, Inc. All code
# herein is licensed under the MIT license.
