=== debian/watch ===
version=4

#opts="uversionmangle=s/_/\./" \
#https://github.com/aja-video/libajantv2/tags \
#s%(?:.*?)?ntv2?(\d[\d.]*)@ARCHIVE_EXT@

#https://github.com/aja-video/libajantv2/archive/refs/tags/ntv2_17_0_1.tar.gz
